//Declare variables
var video = null;
var canvas = null;
var photobutton = null;
var width = 640;
var height = 0;
var streaming = false;

//Gets the feed of the webcam and implements the recoginition button,
//
// which draws the webcam to the canvas, turns it to a blob object and sends it to the API
function recognition() {
		//Declare variables
		video = document.getElementById("webcamFeed");
		canvas = document.getElementById("canvas");
		photobutton = document.getElementById("photobutton");
		
		//Getting the webcam feed
		navigator.getUserMedia = navigator.getUserMedia ||
								 navigator.webkitGetUserMedia ||
								 navigator.mozGetUserMedia ||
								 navigator.msGetUserMedia ||
								 navigator.mediaDevices.getUserMedia;
	
		if (navigator.getUserMedia) {       
			navigator.getUserMedia({video: true}, handleVideo, videoError);
		}

		function handleVideo(stream) {
			video.src = window.URL.createObjectURL(stream);
		}

		function videoError() {
			console.log("An error occured")
		}	

		
		//Resize canvas to match the webcam
		video.addEventListener("canplay", function(ev) {
			if (!streaming) {
					height = video.videoHeight / (video.videoWidth/width);
					if (isNaN(height)) {
						height = width / (4/3);
					}
					video.setAttribute("width", width);
					video.setAttribute("height", height);
					canvas.setAttribute("width", width);
					canvas.setAttribute("height", height);
					streaming = true;
			}
		});
		 
		// Drawing the webcam feed on the canvas
		photobutton.addEventListener('click', function(ev) {
			$(resultID).html('');
			var ctx = canvas.getContext("2d");
			ctx.drawImage(video, 0 , 0);
			var dataU = canvas.toDataURL();
			var file = dataURLtoBlob(dataU);
			recognizePhoto(file);
			alert("Recognizing...");
		});

		// From data URL to Blob Object
		function dataURLtoBlob(dataUrl) {
			// Decode the dataURL    
			var binary = atob(dataUrl.split(',')[1]);
 
			// Create 8-bit unsigned array
			var array = [];
			for (var i = 0; i < binary.length; i++) {
				array.push(binary.charCodeAt(i));
			}
 
			// Return our Blob object
			return new Blob([new Uint8Array(array)], {
				type: 'image/png'
			});
		}
		//Sends the data -album key, album name, Mashape key to the API, canvas image- to the API and displays the response.
		function recognizePhoto(file) {
			var fd = new FormData();
			// Append our Canvas image file to the form data
			fd.append("album", "TFG2016");
			fd.append("albumkey", "9e9b612c51c906696cfebe6ef21b404a126059cbf897128550e38062bb8b7d2b");
			fd.append("files", file);
			
			$.ajax({
				url: "https://lambda-face-recognition.p.mashape.com/recognize",
				type: "POST",
				data: fd,
				processData: false,
				contentType: false,
				beforeSend: function (xhr) {
					xhr.setRequestHeader("X-Mashape-Authorization", "OCfGKAzfbxmsh90jMtijqOBZXXLGp1QdCD1jsncFpHfN5OhSxi");
				}
			}).done(function (data) {
				try {
					var result = data.photos[0].tags[0].uids[0].prediction;
					var conf = data.photos[0].tags[0].uids[0].confidence;
					if (conf > 0.450) {
					$(resultID).html(result);
					console.log(JSON.stringify(data));						
					} else {
					alert("Not sure who you are. Try again.");
					console.log(JSON.stringify(data));						
					}

				} catch(err) {
					alert("Face not detected. Try again.");
				};

			});
		}
		
};

$(document).ready( function() {
	recognition();
});
